/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2011, 2019 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_cg_userdefine.h
* Version      : CodeGenerator for RL78/G14 V2.05.04.02 [20 Nov 2019]
* Device(s)    : R5F104ML
* Tool-Chain   : CCRL
* Description  : This file includes user definition.
* Creation Date: 2020/12/07
***********************************************************************************************************************/

#ifndef _USER_DEF_H
#define _USER_DEF_H

/***********************************************************************************************************************
User definitions
***********************************************************************************************************************/

/* Start user code for function. Do not edit comment generated here */

/* for PMOD interface */
/* UART API definition for the code generator API */
#define R_UARTch_Start      R_UART0_Start
#define R_UARTch_Send       R_UART0_Send
#define R_UARTch_Receive    R_UART0_Receive

#define RY7011_PORT_RESET               P13_bit.no0
#define RY7011_PORT_UART_2WIRE_BRANCH   P7_bit.no4

#define FPB_PORT_SW                     P13_bit.no7

extern volatile uint8_t   g_iic_trans_comp_flag;  /* tranfer complete flag */

enum iic_transfer_state {
    IIC_TRANSFER_NOT_YET,
    IIC_TRANSFER_COMPLETE,
    IIC_TRANSFER_TIMEOUT
};

/* Call back functions structure for bluetooth data transfer. */
typedef void (*cb_cfm_t)(void);
typedef void (*cb_receive_t)(uint8_t *rbuf, uint8_t len);
typedef struct {
    cb_cfm_t        cb_confirmation;    /* Confermation callback  */
    cb_receive_t    cb_receive_data;    /* Write request callback */
} cb_func_t;

/* LED1 and LED2 definition */
#define LED1                P4_bit.no3
#define LED2                P4_bit.no4
#define LED_OFF             1
#define LED_ON              0
#define LED_BLINK_INTERVAL  50  /* 50 * 10ms = 500ms */

/* End user code. Do not edit comment generated here */
#endif
