/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2011, 2021 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_main.c
* Version      : CodeGenerator for RL78/G14 V2.05.04.02 [20 Nov 2019]
* Device(s)    : R5F104ML
* Tool-Chain   : CCRL
* Description  : This file implements main function.
* Creation Date: 2020/12/07
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_cgc.h"
#include "r_cg_port.h"
#include "r_cg_intc.h"
#include "r_cg_serial.h"
#include "r_cg_timer.h"
#include "r_cg_it.h"
/* Start user code for include. Do not edit comment generated here */
#include "arch.h"
#include "rscip_api.h"
#include "timer.h"
#include "rble_app.h"
#include "rble_host.h"
#include "uart.h"
#ifdef USE_SENSOR
#include "r_hs3001.h"
#include "r_hs3001_app.h"
#endif
#include "dataflash.h"
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
void R_MAIN_UserInit(void);

/***********************************************************************************************************************
* Function Name: main
* Description  : This function implements main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void main(void)
{
    R_MAIN_UserInit();
    /* Start user code. Do not edit comment generated here */

    /* Initialize Data Flash driver */
    dataflash_init();

    /* release RESET# of RY7011(RL78/G1D) */
    RY7011_PORT_RESET = 1;
    {
        uint32_t i = 0x100000;/* 500ms */
        while(i--);
    }

    /* P74 for UART 2-wire with branch connection */
    RY7011_PORT_UART_2WIRE_BRANCH = 0;

    /* Enable UART for communication with RL78/G1D */
    R_UARTch_Start();

#ifdef USE_SENSOR
    R_HS3001_APP_Init();
#endif

    /* Enable SW_USR interrupt */
    R_INTC0_Start();

    /* Initialize rBLE Timer */
    if ( RBLE_OK == RBLE_Init_Timer() )
    {
        /* Intialize Application */
        if ( TRUE == APP_Init() )
        {
            /* Main Loop(not break) */
            while(1)
            {
                /* Sequence Management Section */
                APP_Run();

                rBLE_Run();
                
#ifdef USE_SENSOR
                R_HS3001_APP_Run(); /* Pressure, Temperature, Humedity Sensor */
#endif
                
                /* MCU Stop Management Section */
                GLOBAL_INT_DISABLE();
                if(rBLE_Is_Idle() && APP_Is_Idle() && RSCIP_Can_Sleep() && rBLE_Timer_Can_Sleep())
                {
                    __halt();
                }
                GLOBAL_INT_RESTORE();
            }
        }
    }

    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: R_MAIN_UserInit
* Description  : This function adds user code before implementing main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_MAIN_UserInit(void)
{
    /* Start user code. Do not edit comment generated here */
    EI();
    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
